首页 > 其他分享 >LeetCode Hot 100:技巧

LeetCode Hot 100:技巧

时间:2024-10-30 12:51:39浏览次数:7  
标签:return nums int Solution public Hot vector 100 LeetCode

LeetCode Hot 100:技巧

136. 只出现一次的数字

思路 1:哈希表

class Solution {
public:
    int singleNumber(vector<int>& nums) {
        unordered_map<int, int> hashMap;
        for (int& num : nums)
            hashMap[num]++;
        for (auto& [x, cnt] : hashMap)
            if (cnt == 1)
                return x;
        return -1;
    }
};

思路 2:异或

class Solution {
public:
    int singleNumber(vector<int>& nums) {
        int ans = 0;
        for (int& x : nums)
            ans ^= x;
        return ans;
    }
};

思路 3:排序

class Solution {
public:
    int singleNumber(vector<int>& nums) {
        sort(nums.begin(), nums.end());
        for (int i = 0; i < nums.size() - 1; i += 2) {
            if (nums[i] != nums[i + 1])
                return nums[i];
        }
        return nums.back();
    }
};

169. 多数元素

思路 1:哈希表

class Solution {
public:
    int majorityElement(vector<int>& nums) {
        unordered_map<int, int> hashMap;
        for (int& num : nums)
            hashMap[num]++;

        for (auto& [x, cnt] : hashMap)
            if (cnt > nums.size() / 2)
                return x;
        
        return -1;
    }
};

思路 2:排序

class Solution {
public:
    int majorityElement(vector<int>& nums) {
        sort(nums.begin(), nums.end());
        return nums[nums.size() / 2];
    }
};

思路 3:摩尔投票算法(Boyer–Moore majority vote algorithm)

class Solution {
public:
    int majorityElement(vector<int>& nums) {
        int count = 0;
        int candidate = nums[0];
        for (int &num : nums) {
            if (count == 0)
                candidate = num;
                
            if (candidate == num)
                count++;
            else
                count--;
        }

        return candidate;
    }
};

75. 颜色分类

思路 1:三指针

class Solution {
public:
    void sortColors(vector<int>& nums) {
        if (nums.size() < 2)
            return;

        // all in [0, zero) = 0
        // all in [zero, i) = 1
        // all in [two, nums.size() - 1] = 2
        int zero = 0, i = 0, two = nums.size();
        while (i < two) {
            if (nums[i] == 0) {
                swap(nums[zero], nums[i]);
                zero++;
                i++;
            } else if (nums[i] == 1)
                i++;
            else {
                two--;
                swap(nums[i], nums[two]);
            }
        }
    }
};

31. 下一个排列

思路 1:next_permutation

class Solution {
public:
    void nextPermutation(vector<int>& nums) {
        next_permutation(nums.begin(), nums.end());
    }
};

思路 2:两遍扫描

class Solution {
public:
    void nextPermutation(vector<int>& nums) {
        int n = nums.size();
        // Step 1: 找到一个尽量靠右的「较小数」
        int i = n - 2;
        while (i >= 0 && nums[i] >= nums[i + 1])
            i--;
        // Step 2: 找到一个在「较小数」右侧尽可能小的「较大数」
        if (i >= 0) {
            int j = n - 1;
            while (j > i && nums[j] <= nums[i])
                j--;
            // Step 3: 交换「较小数」和「较大数」
            swap(nums[i], nums[j]);
        }
        // Sterp 4: 「较大数」右边的数需要按照升序重新排列
        reverse(nums.begin() + i + 1, nums.end());
    }
};

思路 1:哈希表

class Solution {
public:
    int findDuplicate(vector<int>& nums) {
        unordered_map<int, int> hashMap;
        for (int& num : nums)
            hashMap[num]++;

        for (auto& [x, cnt] : hashMap)
            if (cnt >= 2)
                return x;

        return -1;
    }
};

287. 寻找重复数

思路 1:哈希表

class Solution {
public:
    int findDuplicate(vector<int>& nums) {
        unordered_map<int, int> hashMap;
        for (int& num : nums)
            hashMap[num]++;

        for (auto& [x, cnt] : hashMap)
            if (cnt >= 2)
                return x;

        return -1;
    }
};

思路 2:二分查找

class Solution {
public:
    int findDuplicate(vector<int>& nums) {
        int n = nums.size();
        int left = 0, right = n - 1;
        int ans = -1;

        while (left <= right) {
            int mid = left + (right - left) / 2;
            int count = 0;
            for (int& num : nums)
                if (num <= mid)
                    count++;

            if (count <= mid)
                left = mid + 1;
            else {
                right = mid - 1;
                ans = mid;
            }
        }

        return ans;
    }
};

思路 3:二进制

class Solution {
public:
    int findDuplicate(vector<int>& nums) {
        int n = nums.size();
        // 确定二进制下最高位是多少
        int bit_max = 31;
        while (!((n - 1) >> bit_max))
            bit_max -= 1;

        int ans = 0;
        for (int bit = 0; bit <= bit_max; bit++) {
            int x = 0, y = 0;
            for (int i = 0; i < n; i++) {
                if (nums[i] & (1 << bit))
                    x += 1;
                if (i >= 1 && (i & (1 << bit)))
                    y += 1;
            }
            if (x > y)
                ans |= 1 << bit;
        }

        return ans;
    }
};

思路 4:快慢指针

class Solution {
public:
    int findDuplicate(vector<int>& nums) {
        int slow = 0, fast = 0;
        
        do {
            slow = nums[slow];
            fast = nums[nums[fast]];
        } while (slow != fast);
        
        slow = 0;
        while (slow != fast) {
            slow = nums[slow];
            fast = nums[fast];
        }
        
        return slow;
    }
};

标签:return,nums,int,Solution,public,Hot,vector,100,LeetCode
From: https://blog.csdn.net/ProgramNovice/article/details/143262255

相关文章

  • 代码随想录算法训练营第六天| leetcode242.有效的字母异位词、leetcode349.两个数组的
    1.leetcode242.有效的字母异位词题目链接:242.有效的字母异位词-力扣(LeetCode)文章链接:代码随想录视频链接:学透哈希表,数组使用有技巧!Leetcode:242.有效的字母异位词哔哩哔哩bilibili自己的思路:首先就是对字符串进行分开成一个一个单独的字母,然后使用列表存储这些数据,再对......
  • 【LeetCode】两数之和、大数相加
    主页:HABUO......
  • leetcode155. 最小栈
    设计一个支持 push ,pop ,top 操作,并能在常数时间内检索到最小元素的栈。实现 MinStack 类:MinStack() 初始化堆栈对象。voidpush(intval) 将元素val推入堆栈。voidpop() 删除堆栈顶部的元素。inttop() 获取堆栈顶部的元素。intgetMin() 获取堆栈中的最小元素......
  • Leetcode 3216. 交换后字典序最小的字符串
    因为字符串长度只有100,所以直接模拟就行了。字符串比较不想写的话,可以用C的strcmp1classSolution{2public:3stringswap(string&s,inti,intj){4stringres="";5for(intk=0;k<i;k++)6res+=s[k];7res+=s[j];......
  • [LeetCode] 3216. Lexicographically Smallest String After a Swap
    Givenastringscontainingonlydigits,returnthelexicographicallysmalleststringthatcanbeobtainedafterswappingadjacentdigitsinswiththesameparityatmostonce.Digitshavethesameparityifbothareoddorbothareeven.Forexample,5......
  • 代码生产力提高100倍,Claude-3.5 +Cline 打造超强代码智能体!小白也能开发各种app!
    嘿,各位小伙伴们。今天,带大家走进神奇的AI世界,一起探索强大的工具和技术。最近,Anthropic发布了全新的Claude-3.5-sonnet模型,这可是Claude-3.5-sonnet模型的升级版哦!这款最新的模型在多方面的能力都有了显著提升,尤其是在编程方面。已经完全超越GPT模型,并且其训练数据的截......
  • 0x02 Leetcode Hot100 哈希
    前置知识掌握每种语言的基本数据类型及其时间复杂度。Python:list、tuple、set、dictC++:STL中的vector、set、mapJava:集合类中的List、Set、Map为什么是哈希?在不同语言中,对于字典(dict)类的数据都会先将其键(key)进行哈希(Hash)运算,这个Hash值决定了键值对在内存中的存储位置,因此......
  • Python从0到100(六十八):Python OpenCV-图像边缘检测及图像融合
    前言:零基础学Python:Python从0到100最新最全教程。想做这件事情很久了,这次我更新了自己所写过的所有博客,汇集成了Python从0到100,共一百节课,帮助大家一个月时间里从零基础到学习Python基础语法、Python爬虫、Web开发、计算机视觉、机器学习、神经网络以及人工智能相关知......
  • SS241007D. 航行(sail)
    SS241007D.航行(sail)题意在区间\([1,n]\)上,每个位置有参数\(p_i\),每个时刻,你在\(i\)航道,有\(p_i\)的概率速度\(-1\),有\(1-p_i\)的概率速度\(+1\),然后你会来到\(i+v\)的位置。如果你走到了\(1\)左边或者\(n\)右边,行驶结束。问对于每个位置\(i\in[1,n]\),\(0......
  • Leetcode73. 矩阵置零
    问题描述:给定一个 mxn的矩阵,如果一个元素为0,则将其所在行和列的所有元素都设为0。请使用原地算法。示例1:输入:matrix=[[1,1,1],[1,0,1],[1,1,1]]输出:[[1,0,1],[0,0,0],[1,0,1]]示例2:输入:matrix=[[0,1,2,0],[3,4,5,2],[1,3,1,5]]输出:[[0,0,0,0],[0,......